/* Copyright Feb 2013 O'Neil Delpratt, Stelios Joannou, Andreas Poyias and Rajeev Raman
 * University of Leicester
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 */


#include "Traversals.h"



void Traversals::TreeWalkTest(SDOM_Node* pnode){
 	myNodeCount++;

	if ( pnode->getNodeType() == 1)
 	{
	
		myElemCount++;
	
 	}
	if ( pnode->getNodeType() == 5){
	    
	}
	pnode =pnode->getFirstChild();

	if(pnode!=NULL && pnode->getNodeType()==3){
	
	}
	
	
 	while ( pnode != NULL ){
		TreeWalkTest(pnode);	
		pnode=pnode->getNextSibling();
	}
}

void Traversals::DOTWCOUNT(){
   SDOM_Node* current=myWalker->getCurrentNode(); 
 myWalker->setNodeNr(rootNode);
   int check=0;
  myNodeCount++;
  while (current!=NULL){

      if(check<2){
       if(current->getNodeType()==ELEMENT){
	
	myElemCount++;
      } else{
	if(current->getNodeType()==TEXT)
	  myTextCount++;
      }
       current=myWalker->getFirstChild();
      if(current!=NULL){
	check=0;
      }else{
	current=myWalker->getNextSibling();
	if(current!=NULL){
	  check=1;
	}else{
	  current=myWalker->getParentNode();
	  check=2;
	  myNodeCount--;
	}
      }
     }else{
       current=myWalker->getNextSibling();
       if(current!=NULL){
	 check=1;
       }else{
	 current=myWalker->getParentNode();
	 check=2;
	 myNodeCount--;
       }
     }
     myNodeCount++;
  }
}
    
void Traversals::DOTWCOUNTFULL(){

  SDOM_Node* current=myWalker->getCurrentNode(); 
  int check=0;
  myNodeCount++;
  int node_n=0;
  int otherNode=0;
  int attLength=0;
  countMatch=0;
  while (current!=NULL){
     
    if(check<2){ 
      if((myWalker->getCurrentNode())->getNodeType()==ELEMENT){
 
	myElemCount++;

	//namedNodeMap updated for each new element node
	// without the creation of new object.
        SDOM_NamedNodeMap * myMap = myNode->getAttributes(); 
	attLength=myMap->getLength();
	myAttrCount+=attLength;
       
	for(int i=0;i<attLength;i++){
	  current= myMap->item(i);
	 
	  countMatch+=matchSubString(current->getNodeValue(), "x");
	}
      }else{ 
	if((myWalker->getCurrentNode())->getNodeType()==TEXT){ 
	  myTextCount++;
	  countMatch+=matchSubString(current->getNodeValue(), "x");
	}
      }
      current=myWalker->getFirstChild();
      if(current!=NULL){
	check=0;
      }else{ 
	current=myWalker->getNextSibling();
	if(current!=NULL){ 
	  check=1;
	}else{ 
	  current=myWalker->getParentNode();
	  check=2;
	  myNodeCount--;
	}
      }
    }else{
      current=myWalker->getNextSibling();

      if(current!=NULL){
	check=1;
      }else{
	current=myWalker->getParentNode();
	check=2;
	myNodeCount--;
      }
    }
    myNodeCount++;
  }
}
    
    
void Traversals::RDOTWCOUNT(){

  SDOM_Node* current=myWalker->getCurrentNode(); 
  int check=0;
  myNodeCount++;
   
  while (current!=NULL){
     
    if(check<2){
      if(current->getNodeType()==ELEMENT){
	myElemCount++;
      } else{
        if(current->getNodeType()==TEXT)
	  myTextCount++;
      }
      current=myWalker->getLastChild();
      if(current!=NULL){
	check=0;
      }else{ 
	current=myWalker->getPreviousSibling();
	if(current!=NULL){ 
	  check=1;
	}else{ 
	  current=myWalker->getParentNode();
	  check=2;
	  myNodeCount--;
	}
      }
    }else{
      current=myWalker->getPreviousSibling();
      if(current!=NULL){
	check=1;
      }else{
	current=myWalker->getParentNode();
	check=2;
	myNodeCount--;
      }
    }
    myNodeCount++;
  }
}
    
    
void Traversals::RDOTWCOUNTFULL(){

  SDOM_Node* current=myWalker->getCurrentNode();
 myWalker->setNodeNr(rootNode); 
  int check=0;
  myNodeCount++;
  int attLength=0;
  while (current!=NULL){
     
    if(check<2){ 
      current=myWalker->getLastChild();
      if(current!=NULL){
	check=0;
      }else{ 
	if((myWalker->getCurrentNode())->getNodeType()==ELEMENT){
 
	  myElemCount++;

          SDOM_NamedNodeMap * myMap = myNode->getAttributes(); 
   	  attLength=myMap->getLength();
	  myAttrCount+=attLength;
       
	for(int i=0;i<attLength;i++){
	  current= myMap->item(i);
	 
	  countMatch+=matchSubString(current->getNodeValue(), "x");
	}
       
	}else{ 
	  if((myWalker->getCurrentNode())->getNodeType()==TEXT){ 
	    myTextCount++;
	    countMatch+=matchSubString(myWalker->getCurrentNode()->getNodeValue(), "x");
	  }
	}
	current=myWalker->getPreviousSibling();
	if(current!=NULL){ 
	  check=1;
	}else{ 
	 
	  current=myWalker->getParentNode();
	  check=2;
	  myNodeCount--;
	}
      }
    }else{
      if((myWalker->getCurrentNode())->getNodeType()==ELEMENT){
 
	myElemCount++;
	SDOM_NamedNodeMap * myMap = (myWalker->getCurrentNode())->getAttributes(); 
	attLength=myMap->getLength();
	myAttrCount+=attLength;
       
	for(int i=0;i<attLength;i++){
	  current= myMap->item(i);
	 
	  countMatch+=matchSubString(current->getNodeValue(), "x");
	}
      }else{ 
	if((myWalker->getCurrentNode())->getNodeType()==TEXT){ 
	  myTextCount++;
	  countMatch+=matchSubString(myWalker->getCurrentNode()->getNodeValue(), "x");
	}
      }
      current=myWalker->getPreviousSibling();
      if(current!=NULL){
	check=1;
      }else{
	current=myWalker->getParentNode();
	check=2;
	myNodeCount--;
      }
    }
    myNodeCount++;
  }
}
    
    
void Traversals::DOTWNEXTOPCOUNT(){

  SDOM_Node* current=myWalker->getCurrentNode(); 
  myWalker->setNodeNr(rootNode);
  while (current!=NULL){
    myNodeCount++;
    if(current->getNodeType()==ELEMENT){
      myElemCount++;
    }
    else{
      if(current->getNodeType()==TEXT)
	myTextCount++;
    }
    current=myWalker->getNextNode();
  } 
}
    
void Traversals::DOTWNEXTOPCOUNTFULL(){

  SDOM_Node* current=myWalker->getCurrentNode(); 
  myWalker->setNodeNr(rootNode);
  int attLength=0;
  while (current!=NULL){
    myNodeCount++;
    if((myWalker->getCurrentNode())->getNodeType()==ELEMENT){
      myElemCount++;
      	SDOM_NamedNodeMap * myMap = (myWalker->getCurrentNode())->getAttributes(); 
	attLength=myMap->getLength();
	myAttrCount+=attLength;
       
	for(int i=0;i<attLength;i++){
	  current= myMap->item(i);
	 
	  countMatch+=matchSubString(current->getNodeValue(), "x");
	}
    }else{ 
      if((myWalker->getCurrentNode())->getNodeType()==TEXT){ 
	myTextCount++;	 
	countMatch+=matchSubString(current->getNodeValue(), "x");
      }
    }
    current=myWalker->getNextNode();
    check++;
  }
}
    
void Traversals::RDOTWNEXTOPCOUNT(){

  myWalker->setNodeNr(lastNode);
  SDOM_Node* current=myWalker->getCurrentNode(); 


  while (current!=NULL){
    myNodeCount++;
    if(current->getNodeType()==ELEMENT){
      myElemCount++;
    }
    current=myWalker->getPreviousNode();
    check++;
  }    
}
    
    
void Traversals::RDOTWNEXTOPCOUNTFULL(){
  
  SDOM_Node* current=myWalker->getCurrentNode(); 
  myWalker->setNodeNr(lastNode);
  int attLength=0;
  
  while (current!=NULL){
    if((myWalker->getCurrentNode())->getNodeType()==ELEMENT){
      myElemCount++;
       SDOM_NamedNodeMap * myMap = myNode->getAttributes(); 
	attLength=myMap->getLength();
	myAttrCount+=attLength;
       
      for(int i=0;i<attLength;i++){
	current= myWalker->getCurrentNode()->getAttributes()->item(i);
	countMatch+=matchSubString(current->getNodeValue(), "x");
      }
    }else{ 
      if((myWalker->getCurrentNode())->getNodeType()==TEXT){ 
	myTextCount++;
	countMatch+=matchSubString(current->getNodeValue(), "x");
      }
    }
    myNodeCount++;
    if(current->getNodeType()==ELEMENT){
      myElemCount++;
    }
    current=myWalker->getPreviousNode();
    check++;
  }
}
    
void Traversals::DONODECOUNT(){

//  SDOM_Node* current;
 myNode=rootNode;
   SDOM_Node* current=myNode;
 // myNode->setNodeValue(rootNodeV);
  int check=0;
  myNodeCount++;
  int node_n=0;
  int otherNode=0;
  int attLength=0;
  while (myNode!=NULL){
    if(check<2){
      myNodeCount++;
      if(myNode->getNodeType()==ELEMENT){
	//SDOM_NodeList* myList = myNode->getChildNodes();
	myElemCount++;
	 SDOM_NamedNodeMap * myMap = myNode->getAttributes(); 
	  attLength=myMap->getLength();
	if(attLength>0){
//          SDOM_NamedNodeMap * myMap = myNode->getAttributes(); 
//	  attLength=myMap->getLength();
          myAttrCount+=attLength;

      for(int i=0;i<attLength;i++){
      }
	}
     }else{

	if(myNode->getNodeType()==TEXT){
	  myTextCount++;
	}
      }

      current=myNode->getFirstChild();


      if(current!=NULL){
	myNode=current;
	check=0;
      }else{

	current=myNode->getNextSibling();

	if(current!=NULL){
         	  myNode=current;
	  check=1;
	}else{

	  myNode=myNode->getParentNode();
          
          
	  check=2;
	 // myNodeCount--;
	  //myElemCount--;
	}
      }
    }else{

      current=myNode->getNextSibling();
      if(current!=NULL){
        
	myNode=current;
	check=1;
      }else{

	myNode=myNode->getParentNode();
        
	check=2;
	//myNodeCount--;
	//myElemCount--;
      }
    }
    
  }    
}

void Traversals::RDONODECOUNT(){
   
  SDOM_Node* current;
  int check=0;
  myNodeCount++;
  int node_n=0;
  int otherNode=0;
  int attLength=0;
  while (myNode!=NULL){
     
    if(check<2){
      if(myNode->getNodeType()==ELEMENT){
	myElemCount++;
      }else{
	if(myNode->getNodeType()==TEXT){
	  myTextCount++;
	}
      }
      current=myNode->getLastChild();
      if(current!=NULL){
	myNode=current;
	check=0;
      }else{

	current=myNode->getPreviousSibling();
	if(current!=NULL){ 	   
	  myNode=current;
	  check=1;
	}else{
	  myNode=myNode->getParentNode();
	  check=2;
	  myNodeCount--;
	  //myElemCount--;
	}
      }
    }else{

      current=myNode->getPreviousSibling();
      if(current!=NULL){
	myNode=current;
	check=1;
      }else{
	myNode=myNode->getParentNode();
	check=2;
	myNodeCount--;
	//myElemCount--;
      }
    }
    myNodeCount++;
  }    
}

void Traversals::DONODECOUNTFULL(){
   
  SDOM_Node* current;
  int check=0;
  myNodeCount++;
  int node_n=0;
  int otherNode=0;
  int attLength=0;
  while (myNode!=NULL){
     
    if(check<2){
      if(myNode->getNodeType()==ELEMENT){
	myElemCount++;
	attLength=(myNode->getAttributes())->getLength();
	myAttrCount+=attLength;
       
	for(int i=0;i<attLength;i++){
	  current= myNode->getAttributes()->item(i);
	  countMatch+=matchSubString(current->getNodeValue(), "x");
	}
      }else{ 
	if(myNode->getNodeType()==TEXT){ 
	  myTextCount++;
	  countMatch+=matchSubString(myNode->getNodeValue(), "x");
	}
      }
      current=myNode->getFirstChild();

      if(current!=NULL){
	myNode=current;
	check=0;
      }else{
	current=myNode->getNextSibling();

	if(current!=NULL){ 
	  myNode=current;
	  check=1;
	}else{
	  myNode=myNode->getParentNode();
	  check=2;
	  myNodeCount--;
	}
      }
    }else{
      current=myNode->getNextSibling();
      if(current!=NULL){
	myNode=current;
	check=1;
      }else{
	myNode=myNode->getParentNode();
	check=2;
	myNodeCount--;
      }
    }
    myNodeCount++;
  }    
}

void Traversals::RDONODECOUNTFULL(){
   
  SDOM_Node* current;
  int check=0;
  myNodeCount++;
  int node_n=0;
  int otherNode=0;
  int attLength=0;
  while (myNode!=NULL){
          
    if(check<2){
   
      current=myNode->getLastChild();
      if(current!=NULL){
	myNode=current;
	check=0;
      }else{
	if(myNode->getNodeType()==ELEMENT){
	  myElemCount++;
	  attLength=(myNode->getAttributes())->getLength();
	  myAttrCount+=attLength;
       
	  for(int i=0;i<attLength;i++){
	    current= myNode->getAttributes()->item(i);
	    countMatch+=matchSubString(current->getNodeValue(), "x");
	  }
	}else{ 
	  if(myNode->getNodeType()==TEXT){ 
	    myTextCount++;
	    countMatch+=matchSubString(myNode->getNodeValue(), "x");
	  }
	}
	current=myNode->getPreviousSibling();
	if(current!=NULL){ 	   
	  myNode=current;
	  check=1;
	}else{
	  myNode=myNode->getParentNode();
	  check=2;
	  myNodeCount--;
	  myElemCount--;
	}
      }
    }else{
      if(myNode->getNodeType()==ELEMENT){
	myElemCount++;
	attLength=(myNode->getAttributes())->getLength();
	myAttrCount+=attLength;
       
	for(int i=0;i<attLength;i++){
	  current= myNode->getAttributes()->item(i);
	  countMatch+=matchSubString(current->getNodeValue(), "x");
	}
      }else{ 
	if(myNode->getNodeType()==TEXT){ 
	  myTextCount++;
	  countMatch+=matchSubString(myNode->getNodeValue(), "x");
	}
      }
      current=myNode->getPreviousSibling();
      if(current!=NULL){
	myNode=current;
	check=1;
      }else{
	myNode=myNode->getParentNode();
	check=2;
	myNodeCount--;
	myElemCount--;
      }
    }
    myNodeCount++;
  }    
}


void Traversals::ALRTW(){
  SDOM_Node* current=myWalker->getCurrentNode(); 

  int check=0;
  myNodeCount++;
  int tempDepth=0;
  while (current!=NULL){
    if(check<2){
      if(current->getNodeType()==ELEMENT){
	myElemCount++;
      } else{
	if(current->getNodeType()==TEXT)
	  myTextCount++; 
      }

      current=myWalker->getFirstChild();

      if(current!=NULL){
	check=0;
      }else{

	tempDepth=reversePath(myWalker->getCurrentNode());
	if(tempDepth>maxDepth)maxDepth=tempDepth;

	current=myWalker->getNextSibling();

	if(current!=NULL){ 
	  check=1;
	}else{

	  current=myWalker->getParentNode();

	  check=2;
	  //myNodeCount--;
	  // myElemCount--;
	}
      }
    }else{
      current=myWalker->getNextSibling();
      if(current!=NULL){
	check=1;
      }else{
	current=myWalker->getParentNode();
	check=2;
	//myNodeCount--;
	//myElemCount--;
      }
    }
    myNodeCount++;
  }
}

 void Traversals::RecursiveTraversal( SDOM_Node* pnode){
	 	myNodeCount+=1;

		if ( pnode->getNodeType() == 1)
	 	{
	
			myElemCount+=1;
		
	 	}
		if ( pnode->getNodeType() == 5){
		    
		}
		pnode =pnode->getFirstChild();

		if(pnode!=NULL && pnode->getNodeType()==3){
			myTextCount++;
		}
		
		
	 	while ( pnode != NULL ){
			RecursiveTraversal(pnode);	
			pnode=pnode->getNextSibling();
		}
	}

void Traversals::doTraversals(int option,int repCount) {        
  switch(option){
  case 1:{

    for(int i=0;i<repCount;i++){
      DOTWCOUNT();
    }
    break;
  }
  case 2:{
    for(int i=0;i<repCount;i++){
      RDOTWCOUNT();
    }
    break;
  }
    
  case 3:{
    for(int i=0;i<repCount;i++){
      DOTWNEXTOPCOUNT();
    }
    break;
  }
   
  case 4:{
    for(int i=0;i<repCount;i++){
      RDOTWNEXTOPCOUNT();
    }
    break;
  }
  case 5:{
    for(int i=0;i<repCount;i++){
      DOTWCOUNTFULL();
    }
    break;
  }
      
  case 6:{
    for(int i=0;i<repCount;i++){
      RDOTWCOUNTFULL();
    }
    break;
  }
      
  case 7:{
    for(int i=0;i<repCount;i++){
      DOTWNEXTOPCOUNTFULL();
    }
    break;
  }
    
  case 8:{
    for(int i=0;i<repCount;i++){
      RDOTWNEXTOPCOUNTFULL();
    }
    break;
  }
  case 9:{
    for(int i=0;i<repCount;i++){
      DONODECOUNT();
    }
    break;
  }
  case 10:{
    for(int i=0;i<repCount;i++){
      RDONODECOUNT();
    }
    break;
  }
  case 11:{
    for(int i=0;i<repCount;i++){
      DONODECOUNTFULL();
    }
    break;
  }
  case 12:{
    for(int i=0;i<repCount;i++){
      RDONODECOUNTFULL();
    }
    break;
  }
case 13:{
   for(int i=0;i<repCount;i++){
      ALRTW();
    }
  }
  }

}
