/* Copyright Feb 2013 O'Neil Delpratt, Stelios Joannou and Rajeev Raman
 * University of Leicester
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 */

#ifndef EXPLICITPREFIXSUM_H_
#define EXPLICITPREFIXSUM_H_

#include "PrefixSum.h"
#include <iostream>

class ExplicitPrefixSum: public PrefixSum{
public:
	ExplicitPrefixSum(){}
	ExplicitPrefixSum(unsigned int *arr, int size);
	~ExplicitPrefixSum(){}

	//starting from zero
	inline unsigned int sum(int i){
		return explicitPS[i];
	}

private:
	unsigned int * explicitPS;
	int k;
};
#endif
