/* Copyright Feb 2013 O'Neil Delpratt, Stelios Joannou and Rajeev Raman
 * University of Leicester
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 */
 
#ifndef PREFIXSUM_H_
#define PREFIXSUM_H_


typedef struct{
  	unsigned int start;
	unsigned int end;
}tOffset;

class PrefixSum{


public:
	virtual unsigned int sum(int i)=0;
	
        virtual double spaceUsage(){
          return 0;
        }

};
#endif
